// QT؂̗p

#include <stdio.h>
#include "Member.h"
#include "BinTree.h"

/*--- j[ ---*/
typedef enum {
	TERMINATE, ADD, REMOVE, SEARCH, PRINT
} Menu;

/*--- j[I ---*/
Menu SelectMenu(void)
{
	int ch;

	do {
		printf("\n(1)} (2)폜 (3)T (4)\ (0)IF");
		scanf("%d", &ch);
	} while (ch < TERMINATE || ch > PRINT);
	return (Menu)ch;
}

/*--- C֐ ---*/
int main(void)
{
	Menu    menu;
	BinNode *root = NULL;		// QT؂̍ւ̃|C^

	do {
		Member x;
		BinNode *temp;

		switch (menu = SelectMenu()) {
		 /*--- m[h̑} ---*/
		 case ADD :
				x = ScanMember("}", MEMBER_NO | MEMBER_NAME);
				root = Add(root, &x);
				break;

		 /*--- m[h̍폜 ---*/
		 case REMOVE :
				x = ScanMember("폜", MEMBER_NO);
				Remove(&root, &x);
				break;

		 /*--- m[h̒T ---*/
		 case SEARCH :
				x = ScanMember("T", MEMBER_NO);
				if ((temp = Search(root, &x)) != NULL)
					PrintLnMember(&temp->data);
				break;

		 /*--- Sm[h̕\ ---*/
		 case PRINT :
				puts("yꗗ\z");
				PrintTree(root);
				break;
		}
	} while (menu != TERMINATE);

	FreeTree(root);

	return 0;
}
